.586 
.model flat, stdcall
option casemap:none



	include windows.inc
	include user32.inc
	include kernel32.inc
	include masm32.inc
	includelib user32.lib	
	includelib kernel32.lib
	includelib masm32.lib
	includelib ws2_32.lib



	inet_addr					PROTO :DWORD
	gethostbyaddr					PROTO :DWORD, :DWORD, :DWORD
	gethostbyname					PROTO :DWORD
	WSAGetLastError					PROTO
	WSAStartup					PROTO :DWORD, :DWORD
	WSACleanup					PROTO
	OutputNumber					PROTO OUT_NUMBER:DWORD
	wsprintfA					PROTO C :DWORD,:VARARG
	wsprintf					EQU <wsprintfA>
	AF_INET						EQU 2
	ERROR_HOST_NOT_FOUND				EQU 11001
	ERROR_WS2_32_DLL_NOT_INITIALIZED		EQU 10093
	ERROR_UNK					EQU 11004



.data
HOSTENT							STRUCT
	h_name						DWORD ?
	h_alias						DWORD ?
	h_addr						WORD ?
	h_len						WORD ?
	h_list						DWORD ?
HOSTENT							ENDS
PHOSTENT						TYPEDEF PTR HOSTENT
	whostent					HOSTENT <?>
;WSADATA						STRUCT
;	wVersion					WORD ?
;	wHighVersion					WORD ?
;	baDescription					DB 256 dup (?)
;	baStatus					DB 256 dup (?)
;	Sockets						WORD ?
;	Ignored						WORD ?
;	VendorInformation				PBYTE ?
;WSADATA						ENDS
;PWSSDATA						TYPEDEF PTR WSADATA
	start_struct					WSADATA <?>



	mb_title					DB 'SUCCESS!', 0
	mb_msg_inet_addr				DB 'CALL TO inet_addr SUCCEEDED!', 10, 13, 'IP ADDRESS = %d.', 0
	mb_msg_gethostbyname				DB 'CALL TO gethostbyname SUCCEEDED!', 10, 13, 'ERROR CODE = %d.', 0
	mb_msg_gethostbyaddr				DB 'CALL TO gethostbyaddr SUCCEEDED!', 10, 13, 'ERROR CODE = %d.', 0
	mb_msg_not_found				DB 'HOST NOT FOUND!', 0
	mb_title_host_name				DB 'Host name returned from function call.', 0
	mb_msg_startup_failure				DB 'CALL TO WSAStartup FAILED!', 0



	cw_msg						DB 10, 13, 10, 13, '     Freehafer''s 32 Bit Program Is Terminated!', 10, 13, 10, 13, '     (c)2005 INNIEA PUBLISHING CO.  R', 153, 142, 'K NOG!', 10, 13, 10, 13, '     Hit enter key to exit . . . '
	addr_msg					DB 10, 13, 10, 13, '     THE ADDRESS IS: ', 0
	buffy						DB 256 dup(0)
	bytes_to_write					DB 0
	bytes_to_read					DB 0



	num_char_written				DD 0
	num_char_read					DD 0
	w_std_handle					DD 0
	r_std_handle					DD 0
	my_err						DD 0
	start_unword					DD 101h 	; version 1.1



.code
start:
	call GetHandles
	invoke WSAStartup, start_unword, ADDR start_struct
	.if EAX != 0
		invoke MessageBox, 0, ADDR mb_msg_startup_failure, 0, 0
	.elseif EAX == 0
		call GetHostByAddress
		call GetHostByName
	.endif
	invoke WSACleanup
	invoke WriteConsole, w_std_handle, ADDR cw_msg, sizeof cw_msg, ADDR num_char_written, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	invoke ExitProcess, 0


;________________________________________________________________________________



GetHandles proc
	invoke GetStdHandle, -11
	mov w_std_handle, EAX
	invoke GetStdHandle, -10
	mov r_std_handle, EAX
	ret
GetHandles endp



;________________________________________________________________________________



GetHostByAddress proc
	LOCAL ptr_name_host:DWORD
	LOCAL host_addr:DWORD
	LOCAL host_addr_display_1:DWORD
	LOCAL host_addr_display_2:DWORD
	LOCAL host_name[16]:BYTE
	mov host_name[0], 0
	invoke inet_addr, ADDR host_name
	mov host_addr, EAX
	mov host_addr_display_1, EAX
	mov host_addr_display_2, EAX
	.if EAX != -1
		invoke wsprintf, ADDR buffy, ADDR mb_msg_inet_addr, ADDR host_addr_display_1
		invoke MessageBox, 0, ADDR buffy, ADDR mb_title, 0
		ASSUME EDX:PHOSTENT
		invoke gethostbyaddr, ADDR host_addr, sizeof host_addr, 2	; gets host info from address info
		mov EDX, EAX
		movzx ECX, WORD PTR [EDX].h_addr
		mov host_addr, ECX
		mov ECX, [EDX].h_name
		mov ptr_name_host, ECX
		push EAX
		invoke MessageBox, 0, ptr_name_host, ADDR mb_title_host_name, 0
		pop EAX
		ASSUME EDX:NOTHING
		.if EAX != 0
			invoke WSAGetLastError
			mov my_err, EAX
			.if my_err == ERROR_HOST_NOT_FOUND
				invoke MessageBox, 0, 0, ADDR mb_msg_not_found, 0
			.endif
			invoke wsprintf, ADDR buffy, ADDR mb_msg_gethostbyaddr, my_err
			invoke MessageBox, 0, ADDR buffy, ADDR mb_title, 0
		.endif
	.endif
	invoke WriteConsole, w_std_handle, ADDR addr_msg, sizeof addr_msg, ADDR num_char_written, 0
	invoke OutputNumber, host_addr
	ret
GetHostByAddress endp



;________________________________________________________________________________



GetHostByName proc
	LOCAL ptr_name_host:DWORD
	LOCAL host_addr:DWORD
	LOCAL host_name[16]:BYTE
	mov host_name[0], 0
	ASSUME EDX:PHOSTENT
	invoke gethostbyname, ADDR host_name
	mov EDX, EAX
	movzx ECX, WORD PTR [EDX].h_addr
	mov host_addr, ECX
	mov ECX, [EDX].h_name
	mov ptr_name_host, ECX
	ASSUME EDX:NOTHING
	.if EAX != 0
		invoke WSAGetLastError
		mov my_err, EAX
		.if my_err == ERROR_HOST_NOT_FOUND
			invoke MessageBox, 0, 0, mb_msg_not_found, 0
		.endif
		invoke wsprintf, ADDR buffy, ADDR mb_msg_gethostbyname, my_err
		invoke MessageBox, 0, ADDR buffy, ADDR mb_title, 0
		invoke MessageBox, 0, ptr_name_host, ADDR mb_title_host_name, 0
	.endif
	invoke WriteConsole, w_std_handle, ADDR addr_msg, sizeof addr_msg, ADDR num_char_written, 0
	invoke OutputNumber, host_addr
	ret
GetHostByName endp



;________________________________________________________________________________



OutputNumber proc	USES EBX ECX EDX		OUT_NUMBER:DWORD
	LOCAL COUNTER:DWORD
	mov EAX, OUT_NUMBER
	mov EBX, 10
	mov COUNTER, 0
display_number_loop_next_divide:
	mov EDX, 0
	div EBX
	push EDX
	inc COUNTER
	cmp EAX, 0
	jne display_number_loop_next_divide
display_number_out_loop:
	pop EDX
	add DL, 48
	mov bytes_to_write[0], DL
	invoke WriteConsole, w_std_handle, ADDR bytes_to_write, 1, ADDR num_char_written, 0
	dec COUNTER
	.IF (COUNTER > 0)
	jmp display_number_out_loop
	.ENDIF
	ret
OutputNumber endp



;________________________________________________________________________________



InputNumber proc		USES EBX ECX EDX
	LOCAL IN_NUMBER:DWORD
	mov IN_NUMBER, 0
read_loop:
	mov EBX, 0
	invoke ReadConsole, r_std_handle, ADDR bytes_to_read, 1, ADDR num_char_read, 0
	mov AL, bytes_to_read
	cmp AL, 0
	jne not_special
	jmp short exit_read
not_special:
	cmp AL,'0'
	jb exit_read
	cmp AL, '9'
	ja exit_read
	sub AL, '0'
	mov BL, AL
	mov EAX, IN_NUMBER
	mov ECX, 10
	mul ECX
	mov IN_NUMBER, EAX
	add IN_NUMBER, EBX
	jmp short read_loop
exit_read:
	mov EAX, IN_NUMBER
	ret
InputNumber endp



;________________________________________________________________________________



end start
